/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
function onAuthRequired(headers, errorMsg) {
	return {
		authRequired: true,
		errorMessage: errorMsg ? errorMsg : null
	};
}

function login(username, password) {
	if(username == 'demo' && password == 'demo') {
//	if(username && password) {
		var userIdentity = {
			userId: username,
			displayName: username,
			attributes: {}
		};
		
		WL.Server.setActiveUser("FTRealm", userIdentity);
		return {
			authRequired: false
		};
	}
	
	return onAuthRequired(null, "Invalid username or password");
}

var CABIN_CLASS = {
	'ECONOMY': 'Economy',
	'BUSINESS': 'Business',
	'FIRST': 'First'
};
function searchFlights(queryParams) {
	// generate mock-up data
	function formatTime(time) {
		var hour = Math.floor(time);
		var min = Math.floor((time - hour) * 60);
		return (hour < 10 ? '0' + hour : hour) + 
			':' + (min < 10 ? '0' + min : min);
	}
	
	var numOfFlights = Math.random() * 6;
	var result = {
		flightList: []
	};
	
	for(var i = 0; i < numOfFlights; i++) {
		var departTime = 5 + Math.random() * 19;
		var duration = 1 + Math.random() * 1;
		var reachTime = departTime + duration;
		var price = Math.floor(100 + Math.random() * 200);
		var numOfSeats = Math.floor(Math.random() * 50);
		
		var isReturn = queryParams.isSearchingReturnFlight;
		var departDate = (isReturn ? queryParams.returnDate : queryParams.departDate);
		var departAP = (isReturn ? queryParams.destAP : queryParams.departAP);
		var destAP = (isReturn ? queryParams.departAP : queryParams.destAP);
		result.flightList.push({
			tripType: queryParams.tripType,
			departAP: departAP,
			destAP: destAP,
			departDate: departDate,
			departTime: formatTime(departTime),
			reachTime: formatTime(reachTime),
			price: price, seats: numOfSeats,
			cabinClass: CABIN_CLASS[queryParams.cabinClass]
		});
	}
	
	return result;
}

Date.prototype.format = function(format) {
    var o = {
    	"M+" : this.getMonth()+1, //month
    	"d+" : this.getDate(),    //day
    	"h+" : this.getHours(),   //hour
    	"m+" : this.getMinutes(), //minute
    	"s+" : this.getSeconds(), //second
    	"q+" : Math.floor((this.getMonth()+3)/3),  //quarter
    	"S" : this.getMilliseconds() //millisecond
    };
    if(/(y+)/.test(format)) {
    	format=format.replace(RegExp.$1,
    		(this.getFullYear() + "").substr(4 - RegExp.$1.length));
    }
	for(var k in o) {
		if(new RegExp("("+ k +")").test(format)) {
			format = format.replace(RegExp.$1, 
				RegExp.$1.length==1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
		}
	}
	return format;
};

function createOrder(orderInfo) {
//	orderInfo = eval('(' + orderInfo + ')');
	orderInfo.status = 'UNPAID';
	orderInfo.createdTime = new Date().format("yyyy-MM-dd hh:mm:ss");
	
	return WL.Server.invokeProcedure({
		adapter: 'FTDBAdapter',
		procedure: 'addOrder',
		parameters: [orderInfo]
	});
}

function addOrder(orderInfo) {
	orderInfo = eval('(' + orderInfo + ')');
	return createOrder(orderInfo);
}

function findOrders(userId, filter) {
	var orderList = WL.Server.invokeProcedure({
		adapter: 'FTDBAdapter',
		procedure: 'findOrders',
		parameters: [userId]
	});
	return { orderList: orderList };
}

function updateOrder(orderInfo) {
	orderInfo = eval('(' + orderInfo + ')');
	var result = WL.Server.invokeProcedure({
		adapter: 'FTDBAdapter',
		procedure: 'updateOrder',
		parameters: [orderInfo]
	});
}

function removeOrder(orderInfo) {
	orderInfo = eval('(' + orderInfo + ')');
	var result = WL.Server.invokeProcedure({
		adapter: 'FTDBAdapter',
		procedure: 'removeOrder',
		parameters: [orderInfo.id]
	});
}

function getBookedSeatNo(flightId) {
	/*
	var result = {
		bookedSeatNo: []
	};
	*/
	// return an string instead of an array since there's some weird problems when returning an array here. 
	var result = {
		bookedSeatNo: ''
	};
	
	var chcode = 'A'.charCodeAt(0);
	for(var r = 0; r < 50; r++) {
		for(var c = 0; c < 6; c++) {
			var seatNo = (r + 1) + String.fromCharCode(chcode + c);
			var rand = Math.random();
			if(rand > 0.5) {
				if(result.bookedSeatNo.length > 0) {
					result.bookedSeatNo += ',';
				}
				result.bookedSeatNo += seatNo;
//				result.bookedSeatNo.push(seatNo);
				
			}
		}
	}
	
	return result;
}
