/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
var findAllOrdersStat = WL.Server.createSQLStatement("select * from PUBLIC.FT_ORDER");
var findOrdersStat = WL.Server.createSQLStatement("select * from PUBLIC.FT_ORDER where USERID=?");
function findOrders(userId) {
	var rs;
	if(userId) {
		rs = WL.Server.invokeSQLStatement({
			preparedStatement : findOrdersStat,
			parameters : [userId]
		}).resultSet;
	} else {
		rs = WL.Server.invokeSQLStatement({
			preparedStatement : findAllOrdersStat
		}).resultSet;
	}
	
	var result = [];
	for(var i = 0; i < rs.length; i++) {
		var details = rs[i].DETAILS || '';
		result.push({
			id: rs[i].ID,
			userid: rs[i].USERID,
			status: rs[i].STATUS,
			createdTime: rs[i].CREATED_TIME,
			details: details.split(/\\/).join('')
		});
	}
	return result;
}

var findOrderByCreatedTimdStat = WL.Server.createSQLStatement("select * from PUBLIC.FT_ORDER where CREATED_TIME=?");
var addOrderStat = WL.Server.createSQLStatement("insert into PUBLIC.FT_ORDER(USERID,CREATED_TIME,STATUS,DETAILS) values(?,?,?,?)");
function addOrder(orderInfo) {
	WL.Server.invokeSQLStatement({
		preparedStatement : addOrderStat,
		parameters : [orderInfo.userId, orderInfo.createdTime, orderInfo.status, orderInfo.details]
	});
	
	var rs = WL.Server.invokeSQLStatement({
		preparedStatement : findOrderByCreatedTimdStat,
		parameters : [orderInfo.createdTime]
	}).resultSet;
	
	WL.Logger.error("^^^^^");
	WL.Logger.error(rs);
	
	return {
		id: rs[0].ID,
		userid: rs[0].USERID,
		status: rs[0].STATUS,
		createdTime: rs[0].CREATED_TIME,
		details: rs[0].DETAILS.split(/\\/).join('')
	};
}

var updateOrderStat = WL.Server.createSQLStatement("update PUBLIC.FT_ORDER set STATUS=?, DETAILS=? where ID=?");
function updateOrder(orderInfo) {
	return WL.Server.invokeSQLStatement({
		preparedStatement : updateOrderStat,
		parameters : [orderInfo.status, orderInfo.details, orderInfo.id]
	});
}

var removeOrderStat = WL.Server.createSQLStatement("delete from PUBLIC.FT_ORDER where ID=?");
function removeOrder(orderId) {
	return WL.Server.invokeSQLStatement({
		preparedStatement : removeOrderStat,
		parameters : [orderId]
	});
}