/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	var json = {
			'Hot City': [{
				name: 'Beijing', keys: 'bj,beijing'
			}, {
				name: 'Shanghai', keys: 'sh,shanghai'
			}, {
				name: 'Kunming', keys: 'km,kunming'
			}, {
				name: 'Hangzhou', keys: 'hz,hangzhou'
			}, {
				name: 'Guangzhou', keys: 'gz,guangzhou'
			}, {
				name: 'Chengdu', keys: 'cd,chengdu'
			}, {
				name: 'Xian', keys: 'xa,xian'
			}, {
				name: 'Nanjing', keys: 'nj,nanjing'
			}, {
				name: 'Shenzhen', keys: 'sz,shenzhen'
			}, {
				name: 'Chongqing', keys: 'cq,chongqing'
			}, {
				name: 'Changsha', keys: 'cs,changsha'
			}, {
				name: 'Shenyang', keys: 'sy,shenyang'
			}, {
				name: 'Xiamen', keys: 'xm,xiamen'
			}, {
				name: 'Wuhan', keys: 'wh,wuhan'
			}, {
				name: 'Haikou', keys: 'hk,haikou'
			}, {
				name: 'Wulumuqi', keys: 'wlmq,wulumuqi'
			}, {
				name: 'Qingdao', keys: 'qd,qingdao'
			}, {
				name: 'Dalian', keys: 'dl,dalian'
			}, {
				name: 'Sanya', keys: 'sy,sanya'
			}, {
				name: 'Haerbin', keys: 'heb,haerbin'
			}, {
				name: 'Changchun', keys: 'cc,changchun'
			}, {
				name: 'Nanning', keys: 'nn,nanning'
			}, {
				name: 'Guiyang', keys: 'gy,guiyang'
			}, {
				name: 'Fuzhou', keys: 'fz,fuzhou'
			}, {
				name: 'Zhengzhou', keys: 'zz,zhengzhou'
			}, {
				name: 'Jinan', keys: 'jn,jinan'
			}, {
				name: 'Guilin', keys: 'gl,guilin'
			}, {
				name: 'Tianjin', keys: 'tj,tianjin'
			}, {
				name: 'Taiyuan', keys: 'ty,taiyuan'
			}, {
				name: 'Nanchang', keys: 'nc,nanchang'
			}]
		};
	
	$("#airportSelectPage").live("pageinit", function() {
//		ft.util.decorateButtons("#airportSelectPage .backBtn");
		
		$('#airportList').on('tap', '.airport', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			
			var airportName = $('.airportName', $(this)).text();
			if(window.ft.isSetDepartAP) {
				window.ft.departAP = airportName;
			} else {
				window.ft.destAP = airportName;
			}
			$.mobile.changePage('flight.html', {
				reverse: true
			});
		}).on('vmousedown', '.airport', function(e) {
			$target = $(this).closest('li');
			$target.addClass('ui-btn-active');
			window.ft.$activeLinks.push($target);
		}).on('vmousemove', '.airport', function(e) {
			$(this).closest('li').removeClass('ui-btn-active');;
		});
		
		$('#airportList').html($('#airportList .template'));
		$.each(json, function(tag, airports) {
			var $itemDivider = $('#airportList .template.divider').clone();
			$itemDivider.removeClass('template').text(tag).appendTo('#airportList').show();
			
			$.each(airports, function(i, ap) {
				var $itemAirport = $('#airportList .template.airport').clone();
				$('.airportName', $itemAirport).text(ap.name);
				$itemAirport.removeClass('template').attr('data-filtertext', ap.keys)
					.attr('id', 'airport_' + i).appendTo('#airportList').show();
			});
		});
		$('#airportList').listview('refresh');
	});
})(jq);