/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	$("#contactInfoPage").live("pagebeforeshow", function() {
		if(window.ft.isEditContact) {
			$('#contactName').val(window.ft.contact.name);
			$('#mobile').val(window.ft.contact.mobile);
			$('#email').val(window.ft.contact.email);
			
			$('#addContactBtn, #ccCollapsible').hide();
			$('#saveContactBtn, #deleteContactBtn').show();
		} else {
			$('#contactForm')[0].reset();
			$('#addContactBtn').show();
			$('#saveContactBtn, #deleteContactBtn').hide();
			
			// show recent contacts
			var recentContacts = getRecentContacts();
			$('#recentContactList').html('');
			$('#ccCollapsible').show();
			if(!recentContacts.length) {
				$('#recentContactList').append(
					'<li style="text-align: center;">No Recent Contacts.</li>');
			} else {
				$.each(recentContacts, function(i, contact) {
					var $item = $('<a id="recentContact_' + i + '" href="#">')
						.append(
							'<span>' + contact.name + '<span><br/>' +
							'<span>Mobile: ' + contact.mobile + '</span><br/>' +
							'<span>Email: ' + contact.email + '</span>');
					$('<li>').append($item).appendTo('#recentContactList');
					linkBD('#recentContact_' + i, 'bookTicket.html', {
						isListItem: true,
						onBeforeChange: function() {
							window.ft.contactList.push($.extend({}, contact));
						}
					});
				});
			}
			$('#recentContactList').listview('refresh');
			$('#ccCollapsible').trigger('collapse');
		}
	});
	
	function getRecentContacts() {
		var recentContacts = getItemInLS(RECENT_CONTACT_KEY);
		if(!recentContacts.length) {
			recentContacts = [];
			var p = window.ft.userProfiles[window.ft.userId || 'demo'];
			recentContacts.push({
				name: p.name,
				mobile: p.mobile,
				email: p.email
			});
		}
		return recentContacts;
	}
	
	function saveRecentContacts(recentContacts) {
		setItemInLS(RECENT_CONTACT_KEY, JSON.stringify(recentContacts));
	}
	
	$("#contactInfoPage").live("pageinit", function() {
//		ft.util.decorateButtons("#contactInfoPage .backBtn");
		linkBD('#addContactBtn', 'bookTicket.html', {
			transOpts: { reverse: true },
			onBeforeChange: function() {
				var c = {
					name: $('#contactName').val(),
					mobile: $('#mobile').val(),
					email: $('#email').val()
				};
				window.ft.contactList.push(c);

				// update recent contacts in local storage, keep 2 recent contacts
				var recentContacts = getRecentContacts();
				if(recentContacts.length >= 2) {
					recentContacts = recentContacts.slice(0, 1);
				}
				recentContacts.unshift(c);
				saveRecentContacts(recentContacts);
			}
		});
		linkBD('#saveContactBtn', 'bookTicket.html', {
			transOpts: { reverse: true },
			onBeforeChange: function() {
				window.ft.contact.name = $('#contactName').val(),
				window.ft.contact.mobile = $('#mobile').val(),
				window.ft.contact.email = $('#email').val();
			}
		});
		linkBD('#deleteContactBtn', 'bookTicket.html', {
			transOpts: { reverse: true }, 
			onBeforeChange: function() {
				window.ft.contactList = $.grep(window.ft.contactList, function(c) {
					return c != window.ft.contact;
				});
			}
		});
	});
})(jq);
