/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	var orderList = [];
	
	function renderOrderList() {
		var $templete = $('#orderList .templete').remove();
		var $orderList = $('#orderList').html('');
		var $itemOrderTpl = $templete.filter('.order')
			.clone().removeClass('templete').show();
		if(!orderList || orderList.length == 0) {
			$templete.appendTo($orderList).filter('.noOrders').show();
		} else {
			var divider = {};
			$.each(orderList, function(i, order) {
				order = order.json; // adjust for JSONStore.
				order.details = JSON.parse(order.details);
				if(!divider[order.status]) {
					$('<li data-role="list-divider">').text(order.status).appendTo($orderList);
					divider[order.status] = 1;
				} else {
					divider[order.status] += 1;
				}
				var details = order.details;
				var $itemOrder = $itemOrderTpl.clone()
					.addClass(order.status == 'UNPAID' ? 'ui-body ui-body-c' : 'ui-body ui-body-d')
					.attr('data-order-index', i).appendTo($orderList);
				
				if(divider[order.status] > 1) {
					$itemOrder.css('border-top', '1px solid #AAA');
				}
				
				$('.departDest', $itemOrder).text(
					details.outboundFlight.departAP + ' - ' + details.outboundFlight.destAP + 
					' (' + (details.isRoundTrip ? 'Outbound' : 'One Way') + ')');
				$('.departDate', $itemOrder)
					.text(details.outboundFlight.departDate);
				$('.status', $itemOrder).text(order.status);
			});
			$orderList.listview('refresh').append($templete.hide());
		}
	}
	
	$("#orderPage").live("pagebeforeshow", function() {
		window.ft.orderJS.find({
			'userid': window.ft.userId
		}, {
			onSuccess: function(orders) {
				orderList = orders || [];
				orderList.sort(function(a, b) {
					a = a.json;
					b = b.json;
					if(a.status == b.status) {
						return (a.createdTime > b.createdTime ? -1 : 1);
					} else if(a.status == 'PAID' || 
						(a.status == 'UNPAID' && b.status == 'CANCEL')) {
						return -1;
					} else {
						return 1;
					}
				});
				renderOrderList();
			}, onFailure: function(err) {
				console.log('falied to search orderJS.');
			}
		});
	});
	
	$("#orderPage").live("pageinit", function() {
		$('#orderList').on('tap', '.order', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			var idx = $(this).attr('data-order-index');
			window.ft.order = orderList[idx].json;
			$.mobile.changePage('orderDetails.html');
		}).on('vmousedown', '.order', function(e) {
			$target = $(this).closest('li');
			$(this).addClass('ui-btn-active');
			window.ft.$activeLinks.push($target);
		}).on('vmousemove', '.order', function(e) {
			$(this).closest('li').removeClass('ui-btn-active');
		});
		
//		ft.util.decorateButtons("#orderPage .backBtn");
	});
})(jq);