/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	function renderPassengerInfo(passengerList) {
		var $templete = $('#passengerInfoOD .templete').remove();
		var $passengerList = $('#passengerInfoOD').html('');
		var $itemPassengerTpl = $templete.filter('.passenger')
			.clone().removeClass('templete').show();
		$.each(passengerList, function(i, passenger) {
			var $itemPassenger = $itemPassengerTpl.clone().appendTo($passengerList);
			$('.nameAndType', $itemPassenger)
				.text(passenger.name + ' (' + passenger.type + ')');
			$('.certificate', $itemPassenger)
				.text(CERTIFICATE_TYPE[passenger.certType] + ': ' + passenger.cardNo);
			$('.insurance', $itemPassenger).text(passenger.insurance);
		});
		$passengerList.append($templete);
	}
	
	function renderContactInfo(contactList) {
		var $templete = $('#contactInfoOD .templete').remove();
		var $contactList = $('#contactInfoOD').html('');
		var $itemContactTpl = $templete.filter('.contact')
			.clone().removeClass('templete').show();
		$.each(contactList, function(i, contact) {
			var $itemContact = $itemContactTpl.clone().appendTo($contactList);
			$('.name', $itemContact).text(contact.name);
			$('.mobile', $itemContact).text('Mobile: ' + contact.mobile);
			$('.email', $itemContact).text('Email: ' + contact.email);
		});
		$contactList.append($templete);
	}
	
	$("#orderDetailsPage").live("pagebeforeshow", function() {
		var details = window.ft.order.details;
		var outboundFlight = details.outboundFlight;
		var isRoundTrip = (details.tripType == 'round');
		var returnFlight = details.returnFlight;
		var passengers = details.passengers;
		var contacts = details.contacts;
		var totalPrice = outboundFlight.price;
		if(isRoundTrip) {
			totalPrice += returnFlight.price;
		}
		$.each(passengers, function(i, p) {
			if(p.insurance == 'yes') {
				totalPrice += 5;
			}
		});
		
		$('#OFInfoOD .departDate').text(
			(details.isRoundTrip ? 'Outbound Flight' : 'One Way') + 
			', ' + outboundFlight.departDate);
		$.each(['departAP', 'departTime', 'destAP', 'reachTime'], function(i, prop) {
			$('#OFInfoOD .' + prop).text(outboundFlight[prop]);
		});
		
		if(details.isRoundTrip) {
			$('#RFInfoOD .departDate').text(
				'Return Flight, ' + returnFlight.departDate);
			$.each(['departAP', 'departTime', 'destAP', 'reachTime'], function(i, prop) {
				$('#RFInfoOD .' + prop).text(returnFlight[prop]);
			});
			$('#RFInfoOD').show();
		} else {
			$('#RFInfoOD').hide();
		}
		
		$('#orderInfo .status').html(window.ft.order.status);
		$('#orderInfo .orderId').html(window.ft.order.id);
		$('#orderInfo .price').html(totalPrice);
		
		renderPassengerInfo(passengers);
		renderContactInfo(contacts);
		$('#flightInfoOD').listview('refresh');
		
		$('.payNowBtn,.cancelOrderBtn')[window.ft.order.status == 'UNPAID' ? 'show' : 'hide']();
		$('.checkInBtn')[window.ft.order.status == 'PAID' ? 'show' : 'hide']();
	});
	
	$("#orderDetailsPage").live("pageinit", function() {
//		ft.util.decorateButtons("#orderDetailsPage .backBtn");
		
		function replaceSuccCB() {
			WL.Device.getNetworkInfo(function(netInfo) {
				if(netInfo.isNetworkConnected == 'true') {
					sync(function() {
						alert("Order updated successfully!");
						$.mobile.changePage('order.html', {
							reverse: true
						});
					});
				} else {
					alert('Network not available, using local storage to save data.');
					$.mobile.changePage('order.html', {
						reverse: true
					});
				}
			});
		};
		
		addActiveEffect('#orderDetailsPage .cancelOrderBtn, ' + 
			'#orderDetailsPage .deleteOrderBtn, #orderDetailsPage .payNowBtn');
		
		$('#orderDetailsPage .payNowBtn').bind('tap', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			window.ft.orderJS.find({ id: window.ft.order.id }, {
				onSuccess: function(data) {
					var order = data[0];
					order.json.status = 'PAID';
					window.ft.orderJS.replace(order, {
						onSuccess: replaceSuccCB, onFailure: failureJS
					});
				},
				onFailure: failureJS
			});
		});
		
		$('#orderDetailsPage .cancelOrderBtn').bind('tap', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			window.ft.orderJS.find({ id: window.ft.order.id }, {
				onSuccess: function(data) {
					var order = data[0];
					order.json.status = 'CANCEL';
					window.ft.orderJS.replace(order, {
						onSuccess: replaceSuccCB, onFailure: failureJS
					});
				},
				onFailure: failureJS
			});
		});
		
		function removeSuccCB() {
			WL.Device.getNetworkInfo(function(netInfo) {
				if(netInfo.isNetworkConnected == 'true') {
					sync(function() {
						alert("Order removed successfully!");
						$.mobile.changePage('order.html', {
							reverse: true
						});
					});
				} else {
					alert('Network not available, using local storage to save data.');
					$.mobile.changePage('order.html', {
						reverse: true
					});
				}
			});
		};
//		addActiveEffect('#orderDetailsPage .deleteOrderBtn');
		$('#orderDetailsPage .deleteOrderBtn').bind('tap', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			window.ft.orderJS.find({ id: window.ft.order.id }, {
				onSuccess: function(data) {
					window.ft.orderJS.remove(data, {
						onSuccess: removeSuccCB, onFailure: failureJS
					});
				},
				onFailure: failureJS
			});
		});
		
		linkBD('#orderDetailsPage .checkInBtn', 'selectSeat.html');
	});
})(jq);