/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	function renderPassengerInfo() {
		var $templete = $('#passengerInfoOR .templete').remove();
		var $passengerList = $('#passengerInfoOR').html('');
		var $itemPassengerTpl = $templete.filter('.passenger')
			.clone().removeClass('templete').show();
		$.each(window.ft.passengerList, function(i, passenger) {
			var $itemPassenger = $itemPassengerTpl.clone().appendTo($passengerList);
			$('.nameAndType', $itemPassenger)
				.text(passenger.name + ' (' + passenger.type + ')');
			$('.certificate', $itemPassenger)
				.text(CERTIFICATE_TYPE[passenger.certType] + ': ' + passenger.cardNo);
			$('.insurance', $itemPassenger).text(passenger.insurance);
		});
		$passengerList.append($templete.hide());
	}
	
	function renderContactInfo() {
		var $templete = $('#contactInfoOR .templete').remove();
		var $contactList = $('#contactInfoOR').html('');
		var $itemContactTpl = $templete.filter('.contact')
			.clone().removeClass('templete').show();
		$.each(window.ft.contactList, function(i, contact) {
			var $itemContact = $itemContactTpl.clone().appendTo($contactList);
			$('.name', $itemContact).text(contact.name);
			$('.mobile', $itemContact).text('Mobile: ' + contact.mobile);
			$('.email', $itemContact).text('Email: ' + contact.email);
		});
		$contactList.append($templete.hide());
	}
	
	$("#orderResultPage").live("pagebeforeshow", function() {
		var orderInfo = {
			userId: window.ft.userId,
			details: JSON.stringify({
				outboundFlight: window.ft.outboundFlight || {},
				returnFlight: window.ft.returnFlight || {},
				isRoundTrip: window.ft.isRoundTrip,
				passengers: window.ft.passengerList,
				contacts: window.ft.contactList
			})
		};
		var invocationData = {
			adapter : "FTAdapter",
			procedure : "createOrder",
			parameters : [orderInfo]
		};
		WL.Client.invokeProcedure(invocationData, {
			onSuccess: function(resp) {
				window.ft.orderInfo = resp.invocationResult;
				window.ft.orderJS.store(resp.invocationResult);
				
				$('#OFInfoOR .departDate').text(
					(window.ft.isRoundTrip ? 'Outbound Flight' : 'One Way') + 
					', ' + window.ft.outboundFlight.departDate);
				$.each(['departAP', 'departTime', 'destAP', 'reachTime'], function(i, prop) {
					$('#OFInfoOR .' + prop).text(window.ft.outboundFlight[prop]);
				});
				
				if(window.ft.isRoundTrip) {
					$('#RFInfoOR .departDate').text(
						'Return Flight, ' + window.ft.returnFlight.departDate);
					$.each(['departAP', 'departTime', 'destAP', 'reachTime'], function(i, prop) {
						$('#RFInfoOR .' + prop).text(window.ft.returnFlight[prop]);
					});
					$('#RFInfoOR').show();
				} else {
					$('#RFInfoOR').hide();
				}
				
				var totalPrice = window.ft.outboundFlight.price;
				if(window.ft.isRoundTrip) {
					totalPrice += window.ft.returnFlight.price;
				}
				$.each(window.ft.passengerList, function(i, passenger) {
					if(passenger.insurance == 'yes') {
						totalPrice += 5;
					}
				});
				$('#flightInfoOR .price').text('Total Price: $' + totalPrice);
				
				renderPassengerInfo();
				renderContactInfo();
				$('#flightInfoOR').listview('refresh');
			}
		});
	});
	
	$("#orderResultPage").live("pageinit", function() {
//		ft.util.decorateButtons("#orderResultPage .backBtn");
		linkBD('#backToMain', $('#mainPage'), {
			transOpts: { reverse: true }
		});
		
		$('#payNowBtn').on('tap', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			window.ft.orderJS.find({ id: window.ft.orderInfo.id }, {
				onSuccess: function(data) {
					var order = data[0];
					order.json.status = 'PAID';
					window.ft.orderJS.replace(order, {
						onSuccess: function() {
							sync(function() {
								alert('Your order is paid successfully.');
								$.mobile.changePage('order.html');
							});
						},
						onFailure: failureJS
					});
				},
				onFailure: failureJS
			});
		});
	});
})(jq);