/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	$("#passengerInfoPage").live("pagebeforeshow", function() {
		if(window.ft.isEditPassenger) {
			$('#passengerName').val(window.ft.passenger.name);
			$('#passengerType').text(
				selectcheckboxradio('#passengerTypeOpts', window.ft.passenger.type));
			$('#certType').text(
				selectcheckboxradio('#certificationTypeOpts', window.ft.passenger.certType));
			$('#cardNo').val(window.ft.passenger.cardNo);
			$('#insurance').val(window.ft.passenger.insurance).slider('refresh');
			
			$('#addPassengerBtn, #cpCollapsible').hide();
			$('#savePassengerBtn, #deletePassengerBtn').show();
		} else {
			$('#passengerForm')[0].reset();
			$('#passengerType').text(
				selectcheckboxradio('#passengerTypeOpts', 'adult'));
			$('#certType').text(
				selectcheckboxradio('#certificationTypeOpts', 'identityCard'));
			$('#insurance').val('no').slider('refresh');
			$('#addPassengerBtn').show();
			$('#savePassengerBtn, #deletePassengerBtn').hide();
			
			// show recent passengers
			var recentPassengers = getRecentPassengers();
			$('#recentPassengerList').html('');
			$('#cpCollapsible').show();
			if(recentPassengers.length == 0) {
				$('#recentPassengerList').append(
					'<li style="text-align: center;">No Recent Passengers.</li>');
			} else {
				$.each(recentPassengers, function(i, passenger) {
					var $item = $('<a id="recentPassenger_' + i + '" href="#">')
						.append(
							'<span>' + passenger.name + ' (' + passenger.type + ')<span><br/>' +
							'<span>' + passenger.certType + ': ' + passenger.cardNo + '</span><br/>' +
							'<span>Insurance ($5): ' + passenger.insurance + '</span>');
					$('<li>').append($item).appendTo('#recentPassengerList');
					linkBD('#recentPassenger_' + i, 'bookTicket.html', {
						isListItem: true,
						onBeforeChange: function() {
							window.ft.passengerList.push($.extend({}, passenger));
						}
					});
				});
			}
			$('#recentPassengerList').listview('refresh');
			$('#cpCollapsible').trigger('collapse');
		}
	});
	
	function getRecentPassengers() {
		var recentPassengers = getItemInLS(RECENT_PASSENGER_KEY);
		if(!recentPassengers.length) {
			recentPassengers = [];
			var p = window.ft.userProfiles[window.ft.userId || 'demo'];
			recentPassengers.push({
				name: p.name,
				type: p.passengerInfo.type,
				certType: p.passengerInfo.certType,
				cardNo: p.passengerInfo.cardNo,
				insurance: p.passengerInfo.insurance
			});
		}
		return recentPassengers;
	}
	
	function saveRecentPassengers(recentPassengers) {
		setItemInLS(RECENT_PASSENGER_KEY, JSON.stringify(recentPassengers));
	}
	
	$("#passengerInfoPage").live("pageinit", function() {
//		ft.util.decorateButtons("#passengerInfoPage .backBtn");
		linkBD('#passengerTypeLink', '#passengerTypeOpts', {
			isPopup: true, isListItem: true 
		});
		linkBD('#certificationTypeLink', '#certificationTypeOpts', {
			isPopup: true, isListItem: true 
		});
		
		$('input[name=passengerType], input[name=certificationType]').bind('click', function() {
			$('#passengerTypeLink, #certificationTypeLink').closest('li').removeClass('ui-btn-active');
			var isPassengerType = $(this).attr('name') == 'passengerType';
			$(isPassengerType ? '#passengerType' : '#certType').text($(this).next('label').text());
			$(isPassengerType ? '#passengerTypeOpts' : '#certificationTypeOpts').popup("close");
		});
		
		linkBD('#addPassengerBtn', 'bookTicket.html', {
			transOpts: { reverse: true },
			onBeforeChange: function() {
				var p = {
					type: $('input[name=passengerType]:checked').val(),
					certType: $('input[name=certificationType]:checked').val(),
					name: $('#passengerName').val(),
					cardNo: $('#cardNo').val(),
					insurance: $('#insurance').val()
				};
				window.ft.passengerList.push(p);

				// update recent passengers in local storage, keep 2 recent passengers
				var recentPassengers = getRecentPassengers();
				if(recentPassengers.length >= 2) {
					recentPassengers = recentPassengers.slice(0, 1);
				}
				recentPassengers.unshift(p);
				saveRecentPassengers(recentPassengers);
			}
		});
		linkBD('#savePassengerBtn', 'bookTicket.html', {
			transOpts: { reverse: true },
			onBeforeChange: function() {
				window.ft.passenger.type = $('input[name=passengerType]:checked').val(),
				window.ft.passenger.certType = $('input[name=certificationType]:checked').val(),
				window.ft.passenger.name = $('#passengerName').val(),
				window.ft.passenger.cardNo = $('#cardNo').val(),
				window.ft.passenger.insurance = $('#insurance').val();
			}
		});
		linkBD('#deletePassengerBtn', 'bookTicket.html', {
			transOpts: { reverse: true }, 
			onBeforeChange: function() {
				window.ft.passengerList = $.grep(window.ft.passengerList, function(p) {
					return p != window.ft.passenger;
				});
			}
		});
	});
})(jq);
