/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	var orderList = [];
	
	function renderOrderList() {
		var $templete = $('#orderListCI .templete').remove();
		var $orderList = $('#orderListCI').html('');
		var $itemOrderTpl = $templete.filter('.order')
			.clone().removeClass('templete').show();
		
		var found = false;
		if(orderList) {
			$.each(orderList, function(i, order) {
				order = order.json; // adjust for JSONStore.
				if(order.status == 'PAID') {
					found = true;
					order.details = JSON.parse(order.details);
					var details = order.details;
					var $itemOrder = $itemOrderTpl.clone()
						.attr('data-order-index', i).appendTo($orderList);
					$('.departDest', $itemOrder).text(
						details.outboundFlight.departAP + ' - ' + details.outboundFlight.destAP); // + 
//						' (' + (details.isRoundTrip ? 'Outbound' : 'One Way') + ')');
					$('.departDate', $itemOrder)
						.text(details.outboundFlight.departDate);
					$('.departReachTime', $itemOrder).text(
						details.outboundFlight.departTime + ' - ' + details.outboundFlight.reachTime);
//					$('.status', $itemOrder).text(order.status);
				}
			});
			$orderList.listview('refresh').append($templete.hide());
		}
		
		if(!orderList || orderList.length == 0 || !found) {
			$templete.appendTo($orderList).filter('.noOrders').show();
		}
	}
	
	$("#selectFlightToCheckInPage").live("pagebeforeshow", function() {
		window.ft.orderJS.find({
			'userid': window.ft.userId
		}, {
			onSuccess: function(orders) {
				orderList = orders || [];
				orderList.sort(function(a, b) {
					return (a.json.createdTime > b.json.createdTime ? -1 : 1);
				});
				renderOrderList();
			}, onFailure: function(err) {
				console.log('falied to search orderJS.');
			}
		});
	});
	
	$("#selectFlightToCheckInPage").live("pageinit", function() {
		$('#orderListCI').on('tap', '.order', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			
			var idx = $(this).attr('data-order-index');
			window.ft.order = orderList[idx].json;
			$.mobile.changePage('selectSeat.html');
		}).on('vmousedown', '.order', function(e) {
			$target = $(this).closest('li');
			$(this).addClass('ui-btn-active');
			window.ft.$activeLinks.push($target);
		}).on('vmousemove', '.order', function(e) {
			$(this).closest('li').removeClass('ui-btn-active');
		});
	});
})(jq);