/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	function renderFlightList() {
		$('#outboundFlightList').html($('#outboundFlightList .template'));
		if(!window.ft.outboundFlightList || window.ft.outboundFlightList.length == 0) {
			$('#outboundFlightList .template.noOutboundFlights').show();
		} else {
			$('#outboundFlightList .template.noOutboundFlights').hide();
			
			var props = ['departTime', 'reachTime', 'price', 'seats'];
			$.each(window.ft.outboundFlightList, function(i, flight) {
				var $itemFlight = $('#outboundFlightList .template.outboundFlight').clone();
				$.each(props, function(i, prop) {
					$('.' + prop, $itemFlight).html(flight[prop]);
				});
				$itemFlight.removeClass('template')
					.attr('data-flight-index', i).appendTo('#outboundFlightList').show();
			});
		}
		$('#outboundFlightList').listview('refresh');
	}
	
	$("#selectOutboundFlightPage").live("pagebeforeshow", function() {
		$('#OFDepartDestAP').text(window.ft.departAP + ' to ' + window.ft.destAP);
		$('#OFDepartDate').text(window.ft.departureDate);
		renderFlightList();
	});
	
	$("#selectOutboundFlightPage").live("pageinit", function() {
//		ft.util.decorateButtons("#selectOutboundFlightPage .backBtn");
		
		$('#outboundFlightList').on('tap', '.outboundFlight', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			var idx = $(this).attr('data-flight-index');
			window.ft.outboundFlight = window.ft.outboundFlightList[idx];
			
			if(window.ft.isRoundTrip) {
				window.ft.flightQueryParams.isSearchingReturnFlight = true;
				searchFlights(function(resp) {
					window.ft.returnFlightList = resp.invocationResult.flightList;
					$.mobile.changePage('selectReturnFlight.html');
				});
			} else {
				$.mobile.changePage('bookTicket.html');
			}
		}).on('vmousedown', '.outboundFlight', function(e) {
			$target = $(this).closest('li');
			$(this).addClass('ui-btn-active');
			window.ft.$activeLinks.push($target);
		}).on('vmousemove', '.outboundFlight', function(e) {
			$(this).closest('li').removeClass('ui-btn-active');
		});
		
		$('#OFPrevBtn, #OFNextBtn').on('click', function() {
			busy.show();
			var isNext = ($(this).attr('id') == 'OFNextBtn'); 
			wait(1, function() {
				var date = new Date(window.ft.departureDate.replace(/-/g, '/'));
                date.setDate(date.getDate() + (isNext ? 1 : -1));
				window.ft.departureDate = date.format('yyyy-MM-dd');
				window.ft.flightQueryParams.departDate = window.ft.departureDate;
				$('#OFDepartDate').text(window.ft.departureDate);
				
				window.ft.flightQueryParams.isSearchingReturnFlight = false;
				searchFlights(function(resp) {
					console.log(resp);
					window.ft.outboundFlightList = resp.invocationResult.flightList;
					renderFlightList();
					$('#OFPrevBtn, #OFNextBtn').removeClass('ui-btn-active');
					busy.hide();
				});
			});
			return false;
		});
	});
})(jq);