/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	function renderFlightList() {
		$('#returnFlightList').html($('#returnFlightList .template'));
		if(!window.ft.returnFlightList || window.ft.returnFlightList.length == 0) {
			$('#returnFlightList .template.noReturnFlights').show();
		} else {
			$('#returnFlightList .template.noReturnFlights').hide();
			
			var props = ['departTime', 'reachTime', 'price', 'seats'];
			$.each(window.ft.returnFlightList, function(i, flight) {
				var $itemFlight = $('#returnFlightList .template.returnFlight').clone();
				$.each(props, function(i, prop) {
					$('.' + prop, $itemFlight).text(flight[prop]);
				});
				$itemFlight.removeClass('template')
					.attr('data-flight-index', i).appendTo('#returnFlightList').show();
			});
		}
		$('#returnFlightList').listview('refresh');
	}
	
	function formatDate(aDate) {
//		var date = aDate.toISOString();
//		return date.substring(0, date.indexOf('T'));
		var m = aDate.getMonth() + 1;
		var d = aDate.getDate();
		return aDate.getFullYear() + '-' +
			(m < 10 ? '0' + m : m) + '-' + (d < 10 ? '0' + d : d);
	}
	
	$("#selectReturnFlightPage").live("pagebeforeshow", function() {
		$('#RFDepartDestAP').text(window.ft.destAP + ' to ' + window.ft.departAP);
		$('#RFDepartDate').text(window.ft.returnDate);
		renderFlightList();
	});
	
	$("#selectReturnFlightPage").live("pageinit", function() {
//		ft.util.decorateButtons("#selectReturnFlightPage .backBtn");
		
		$('#returnFlightList').on('tap', '.returnFlight', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			var idx = $(this).attr('data-flight-index');
			window.ft.returnFlight = window.ft.returnFlightList[idx];
			$.mobile.changePage('bookTicket.html');
		}).on('vmousedown', '.returnFlight', function(e) {
			$target = $(this).closest('li');
			$target.addClass('ui-btn-active');
			window.ft.$activeLinks.push($target);
		}).on('vmousemove', '.returnFlight', function(e) {
			$(this).closest('li').removeClass('ui-btn-active');
		});
		
		$('#RFPrevBtn, #RFNextBtn').on('click', function() {
			busy.show();
			var isNext = ($(this).attr('id') == 'RFNextBtn'); 
			wait(1, function() {
				var date = new Date(window.ft.returnDate.replace(/-/g, '/'));
                date.setDate(date.getDate() + (isNext ? 1 : -1));
				window.ft.returnDate = date.format('yyyy-MM-dd');
				window.ft.flightQueryParams.returnDate = window.ft.returnDate;
				$('#RFDepartDate').text(window.ft.returnDate);
				
				window.ft.flightQueryParams.isSearchingReturnFlight = true;
				searchFlights(function(resp) {
					console.log(resp);
					window.ft.returnFlightList = resp.invocationResult.flightList;
					renderFlightList();
					$('#RFPrevBtn, #RFNextBtn').removeClass('ui-btn-active');
					busy.hide();
				});
			});
			return false;
		});
	});
})(jq);